#
#. env_vars
export PATH=$PATH:"$PWD"

exec 2>> err.log

intsize=`cat int.log`

#Run instruction cost test
cd cost
make -C ${intsize} test >> err.log
if [ $? -ne 0 ] ; then
  echo "<Failed>Instruction cost test</Failed>" >> ../result.txt
fi

int32_t_add=`cat */*/*/result.txt | grep value1 | grep int32_t | grep add | awk '{ print $4 }'`
int32_t_sub=`cat */*/*/result.txt | grep value1 | grep int32_t | grep sub | awk '{ print $4 }'`
int32_t_mul=`cat */*/*/result.txt | grep value1 | grep int32_t | grep mul | awk '{ print $4 }'`
int32_t_div=`cat */*/*/result.txt | grep value1 | grep int32_t | grep div | awk '{ print $4 }'`

int64_t_add=`cat */*/*/result.txt | grep value1 | grep int64_t | grep add | awk '{ print $4 }'`
int64_t_sub=`cat */*/*/result.txt | grep value1 | grep int64_t | grep sub | awk '{ print $4 }'`
int64_t_mul=`cat */*/*/result.txt | grep value1 | grep int64_t | grep mul | awk '{ print $4 }'`
int64_t_div=`cat */*/*/result.txt | grep value1 | grep int64_t | grep div | awk '{ print $4 }'`

float_add=`cat */*/*/result.txt | grep value1 | grep float | grep add | awk '{ print $4 }'`
float_sub=`cat */*/*/result.txt | grep value1 | grep float | grep sub | awk '{ print $4 }'`
float_mul=`cat */*/*/result.txt | grep value1 | grep float | grep mul | awk '{ print $4 }'`
float_div=`cat */*/*/result.txt | grep value1 | grep float | grep div | awk '{ print $4 }'`

double_add=`cat */*/*/result.txt | grep value1 | grep double | grep add | awk '{ print $4 }'`
double_sub=`cat */*/*/result.txt | grep value1 | grep double | grep sub | awk '{ print $4 }'`
double_mul=`cat */*/*/result.txt | grep value1 | grep double | grep mul | awk '{ print $4 }'`
double_div=`cat */*/*/result.txt | grep value1 | grep double | grep div | awk '{ print $4 }'`


echo "op_data.op_kind.latency.bits.32-bit.op_type.integer.add_value ${int32_t_add}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.32-bit.op_type.integer.sub_value  ${int32_t_sub}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.32-bit.op_type.integer.mult_value ${int32_t_mul}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.32-bit.op_type.integer.div_value  ${int32_t_div}" >> ../../pace_rcdb

echo "op_data.op_kind.latency.bits.64-bit.op_type.integer.add_value  ${int64_t_add}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.64-bit.op_type.integer.sub_value  ${int64_t_sub}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.64-bit.op_type.integer.mult_value ${int64_t_mul}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.64-bit.op_type.integer.div_value  ${int64_t_div}" >> ../../pace_rcdb


echo "op_data.op_kind.latency.bits.32-bit.op_type.float.add_value  ${float_add}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.32-bit.op_type.float.sub_value  ${float_sub}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.32-bit.op_type.float.mult_value ${float_mul}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.32-bit.op_type.float.div_value  ${float_div}" >> ../../pace_rcdb

echo "op_data.op_kind.latency.bits.64-bit.op_type.float.add_value ${double_add}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.64-bit.op_type.float.sub_value ${double_sub}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.64-bit.op_type.float.mult_value ${double_mul}" >> ../../pace_rcdb
echo "op_data.op_kind.latency.bits.64-bit.op_type.float.div_value ${double_div}" >> ../../pace_rcdb

cd ..
