#! /bin/bash

# The following parameters must be defined
#CC=gcc
#COPT=-O
#PTHREAD_LIBRARY_LINKER_FLAG=-lpthread
#INCLUDE_PATH_FLAG=-I
#LINK_PATH_FLAG=-L
#MACRO_DEF_FLAG=-D
#EXECUTABLE_OUTPUT_FLAG=-o
#PACE_RCDB

# The following parameter is optional
#HWLOC_PATH

LDFLAGS=$PTHREAD_LIBRARY_LINKER_FLAG_TARGET


if [ -n "$HWLOC_PATH_TARGET" ]; then
	echo "HWLOC affinity"
	echo "HWLOC_PATH_TARGET = $HWLOC_PATH_TARGET"
	LDFLAGS+=" -lhwloc"
	export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HWLOC_PATH/lib"
	echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH"
	$CC_TARGET $COPT_TARGET $LDFLAGS $INCLUDE_PATH_FLAG_TARGET $HWLOC_PATH_TARGET/include $LINK_PATH_FLAG_TARGET $HWLOC_PATH_TARGET/lib $MACRO_DEF_FLAG_TARGET HWLOC_AFFINITY affinity.c memboundthreads.c $EXECUTABLE_OUTPUT_FLAG_TARGET memboundthreads

else
	#check for pthread affinity
	testfile="./pthread_affinity_test"
	$CC_TARGET $COPT_TARGET $LDFLAGS pthread_affinity_test.c $EXECUTABLE_OUTPUT_FLAG_TARGET $testfile && \
	$testfile
	
	if [ "$?" -eq 0 ]; then
		echo "PTHREAD affinity"
		$CC_TARGET $COPT_TARGET $LDFLAGS $MACRO_DEF_FLAG_TARGET PTHREAD_AFFINITY affinity.c memboundthreads.c $EXECUTABLE_OUTPUT_FLAG_TARGET memboundthreads

	else
		echo "No thread affinity"
		$CC_TARGET $COPT_TARGET $LDFLAGS $MACRO_DEF_FLAG_TARGET NO_AFFINITY affinity.c memboundthreads.c $EXECUTABLE_OUTPUT_FLAG_TARGET memboundthreads

	fi
fi


#this is now executed by the "run" part of the Makefile
#echo "parallel_contexts.memory_context "`./memboundthreads 0 2>stderroutput.txt` >> $PACE_RCDB

exit 0